require 'rest-client'
require 'json'

require 'qvo/config'
require 'qvo/customers'
require 'qvo/cards'
require 'qvo/plans'
require 'qvo/subscriptions'
require 'qvo/transactions'
require 'qvo/webpay'

module QVO
    extend self

    def resolve_uri(method_uri)
        Configuration.base_url + method_uri
    end

    def get(method_uri)
        response = RestClient.get resolve_uri(method_uri), Configuration.authorization
        JSON.parse response.body, :symbolize_names => true
    end

    def post(method_uri, data = {})
        response = RestClient.post resolve_uri(method_uri), data, Configuration.authorization
        JSON.parse response.body, :symbolize_names => true
    end

    def put(method_uri, data = {})
        response = RestClient.put resolve_uri(method_uri), data, Configuration.authorization
        JSON.parse response.body, :symbolize_names => true
    end

    def delete(method_uri)
        response = RestClient.delete resolve_uri(method_uri), Configuration.authorization
        JSON.parse response.body, :symbolize_names => true
    end

    def config (args = {})
        if args[:credentials]
            data = File.read args[:credentials]
            json = JSON.parse data, :symbolize_names => true
    
            Configuration.base_url = json[:base_url] || 'https://api.qvo.cl'
            Configuration.api_token = json[:api_token]
        else
            yield Configuration
        end
    end
end